# rules to build a library
# based on FreeBSD's bsd.lib.mk

# Copyright 2008 Roy Marples <roy@marples.name>
# All rights reserved. Released under the 2-clause BSD license.

SHLIB_NAME=		${LIB}.so
SONAME?=		${SHLIB_NAME}

SRCS?=			${LIB}.c
OBJS+=			${SRCS:.c=.o}
SOBJS+=			${OBJS:.o=.So}
_LIBS=			${SHLIB_NAME}

CLEANFILES+=		${OBJS} ${SOBJS} ${_LIBS} ${SHLIB_LINK}

.SUFFIXES:		.So

.c.So:
	${CC} ${PICFLAG} -DPIC ${CPPFLAGS} ${CFLAGS} -c $< -o $@

all: depend ${_LIBS}

${SHLIB_NAME}:
# We need to ensure we use libraries in /lib
LDFLAGS+=	-L/${LIBNAME} -Wl,-rpath=/${LIBNAME}

${SHLIB_NAME}:	${SOBJS}
	${CC} ${LDFLAGS} -shared -Wl,-x \
	-o $@ -Wl,-soname,${SONAME} \
	${SOBJS} ${LDADD}

clean:
	rm -f ${OBJS} ${SOBJS} ${_LIBS} ${SHLIB_LINK} ${CLEANFILES}

install: all
	${INSTALL} -d ${DESTDIR}${SHLIBDIR}
	${INSTALL} -m ${LIBMODE} ${SHLIB_NAME} ${DESTDIR}${SHLIBDIR}

include ${MK}/sys.mk
include ${MK}/depend.mk
